/* Versione ricorsiva dell'esercizio 1 */
#include <stdio.h>
#include <stdlib.h>


/* Nodo di un albero binario. 
 * I puntatori ai figli sono nulli
 * nel caso i lnodo sia una foglia. */
typedef struct _nodo {
   int dato;
   struct _nodo *sx;
   struct _nodo *dx;
} nodo;


/* Struttura che rappresenta
 * il tipo di dato astratto 
 * Albero Binario Di Ricerca.
 *
 * Per ora contiene solo un puntatore
 * alla radice, NULL se l'albero e' vuoto.
 */
typedef struct  {
   nodo *radice;
} ABR;


nodo *inserisci(nodo *corrente, int valore)
{
    if (corrente == NULL) {	
       nodo *nuovo = (nodo *)malloc(sizeof(nodo));
       nuovo->dato = valore;
       nuovo->sx = nuovo->dx = NULL;
       
       return nuovo;
    }

    if ( valore <= corrente->dato  ) 
       corrente->sx = inserisci(corrente->sx, valore);	  
    else
       corrente->dx = inserisci(corrente->dx, valore);

    return corrente;
}

int
cerca(nodo *corrente, int val)
{
   int prof_sotto;

   if ( corrente == NULL ) 
	   return -1;

   if ( val == corrente->dato ) 
	   return 1;

   if ( val < corrente->dato ) 
	   prof_sotto = cerca(corrente->sx, val);
   else
	   prof_sotto = cerca(corrente->dx, val);

   if ( prof_sotto == -1 ) return -1;
   return prof_sotto+1;
}



int main()
{
    ABR albero;
    int i, N, val, pos;

    albero.radice = NULL;

    scanf("%d", &N);
    for ( i = 0; i < N; i++ ) 
    {
       scanf("%d", &val);
       albero.radice = inserisci(albero.radice, val);
    }
     
    /* Ciclo infinito che cerca i
     * valori in input da tastiera. */
    while(1) {
      scanf("%d", &val);
      pos = cerca(albero.radice, val);
      if ( pos == -1 )
          printf("NO\n");
      else
          printf("%d\n", pos);
    }
   
}
